<?php

namespace BayCMS\Field;


class Checkbox extends Radio
{
 
    public function getValue(): string
    {
        if (!$this->value && $this->value!=='f')
            return 'f';
        return 't';
    }

    public function setValue($value): bool
    {
        if($value=='f') $value=false;
        $this->error = false;
        if (($this->settings['non_empty'] ?? false) && !$value)
            $this->error = true;
        $this->value = $value;
        return $this->error;
    }

    public function getDisplayValue(): string
    {
        if ($this->value && $this->value!=='f')
            return ($this->context->get('lang') == 'de' ? 'Ja' : 'Yes');
        return ($this->context->get('lang') == 'de' ? 'Nein' : 'No');
    }


    public function getInput(\BayCMS\Fieldset\Form $form): string
    {
        $out = "<input type=\"checkbox\" id=\"" . $this->getID($form) . "\" name=\"" . $this->name . "\" ";
        if ($this->value && $this->value!=='f')
            $out .= ' checked';
        $out .= ($this->settings['input_options'] ?? '') . ">";
        return $out;

    }



}