<?php

namespace BayCMS\Field;

class Color extends Number
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        $options = $settings['input_options'] ?? '';
        $settings['input_options'] = $options . ' type="color"';
        parent::__construct($context, $settings);
    }

    public function getDisplayValue(): string
    {
        if (!$this->value)
            return '';
        $grey = hexdec(substr($this->value, 1, 2))
            + 3 * hexdec(substr($this->value, 3, 2))
            + hexdec(substr($this->value, 5, 2));
        $color = ($grey > 625 ? "#000000" : "#ffffff");
        return '<span style="background-color:' . $this->value . ';color:' . $color . ';">' .
            $this->value . '</span>';
    }
}