<?php

namespace BayCMS\Field;


class Comment extends Field
{
    public function __construct(\BayCMS\Base\BayCMSContext $context,array $settings){
        if(! isset($settings['no_add_to_query'])) $settings['no_add_to_query']=true;
        parent::__construct($context,$settings);
    }

    public function getDisplayValue()
    {
        return $this->settings['description'];
    }


    public function getInput(\BayCMS\Fieldset\Form $form): string
    {
        return '';
    }

    public function setValue($value): bool
    {
        return false;
    }

    public function getFormRow(\BayCMS\Fieldset\Form $form): string
    {
        if( $this->settings['not_in_form']??false) return '';
        $out = '<div class="' . $GLOBALS['TE']->getCSSClass('form_div') . '">'. 
            $this->getDescription() . "</div>\n";
        return $out;
    }


    public function getTableRow()
    {
        if( $this->settings['not_in_table']??false) return '';
        $out = "<tr><td colspan=2>" . $this->getDisplayValue() . "</td></tr>\n";
        return $out;
    }

}