<?php

namespace BayCMS\Field;

class Email extends TextInput
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        $options = $settings['input_options'] ?? '';
        $settings['input_options'] = $options . ' type="email"';
        parent::__construct($context, $settings);
    }

    public function getDisplayValue(): string
    {
        if (!$this->value)
            return '';
        return '<a href="mailto:' . $this->value . '">' . $this->value . '</a>';
    }

}