<?php

namespace BayCMS\Field;

class File extends TextInput
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        if (!isset($settings['no_add_to_query']))
            $settings['no_add_to_query'] = true;
        parent::__construct($context, $settings);
    }

    public function getInput(\BayCMS\Fieldset\Form $form): string
    {
        $out = "<input type=\"file\" id=\"" . $this->getID($form) . "\" name=\"" . $this->name . "\" ";
        if ($this->settings['placeholder'] ?? '')
            $out .= 'placeholder="' . htmlspecialchars($this->settings['placeholder']) . '"';
        if ($this->settings['accept'] ?? '')
            $out .= ' accept="' . $this->settings['accept'] . '"';

        $out .= ' ' . ($this->settings['input_options'] ?? '') . ">";
        return $out;
    }


}

