<?php

namespace BayCMS\Field;

class NumSelect extends Select
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        if (!isset($settings['min']))
            $settings['min'] = 1;
        if (!isset($settings['max']))
            $settings['max'] = 10;
        if (!isset($settings['step']))
            $settings['step'] = 1;

        if ($settings['step'] <= 0)
            throw new \BayCMS\Exception\invalidData("step must be positiv!");

        if ($settings['max'] < $settings['min'])
            throw new \BayCMS\Exception\invalidData("max must be greater than min!");

        $settings['values'] = [];
        $v = $settings['min'];
        while ($v <= $settings['max']) {
            $settings['values'][] = $v;
            $v += $settings['step'];
        }
        parent::__construct($context, $settings);
    }

}