<?php

namespace BayCMS\Field;

class Number extends TextInput
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        $options = $settings['input_options'] ?? '';
        if (isset($settings['step']))
            $options .= ' step="' . $settings['step'] . '"';
        $settings['input_options'] = $options . ' type="number"';
        parent::__construct($context, $settings);
    }

    public function getDisplayValue()
    {
        if (!$this->value)
            return $this->value;
        if ($this->context->get('lang') == 'en')
            return $this->value;
        return str_replace('.', ',', $this->value);
    }

    public function getValue()
    {
        if ($this->value !== null)
            return $this->value;
        return null;
    }

    public function setValue($value): bool
    {
        if ($value === "null")
            $value = null;
        return parent::setValue($value);
    }
}