<?php

namespace BayCMS\Field;

class Radio extends TextInput
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        if (!isset($settings['value']))
            $settings['value'] = $settings['name'];
        parent::__construct($context, $settings);
    }

    public function getInput(\BayCMS\Fieldset\Form $form): string
    {
        $out = "<input type=\"radio\" id=\"" . $this->getID($form) . "\" name=\"" . $this->name . "\" ";
        if ($this->settings['placeholder'] ?? '')
            $out .= 'placeholder="' . htmlspecialchars($this->settings['placeholder']) . '"';

        $out .= " value=\"" . htmlspecialchars($this->settings['value']) . "\"";
        $out .= ($this->settings['input_options'] ?? '');
        if ($this->value == $this->settings['value'])
            $out .= ' checked';
        $out .= ">";
        return $out;
    }

    public function getValue()
    {
        if ($this->value == $this->settings['value'])
            return $this->value;
        return null;
    }

    public function getFormRow(\BayCMS\Fieldset\Form $form): string
    {
        $out = '<div class="' . $GLOBALS['TE']->getCSSClass('form_div') . '">';
        $out .= $this->getInput($form);
        $out .= ' <label for="' . $this->getID($form) . '"';
        $out .= ' style="' . ($this->settings['label_css'] ?? 'width:auto;') . '"';
        $out .= '>' . $this->getDescription() . $this->getHelp($form) . '</label>';
        $out .= "</div>\n";
        return $out;
    }




}