<?php

namespace BayCMS\Field;

class SelectJS extends Select
{

    public function getInput($form): string
    {
        $out = "";
        // DB-Anfrage db_query mit Platzhalter $value$

        $target = $this->settings['target'];
        if (!strstr($target, "?"))
            $target .= "?js_select=1";

        $name = $this->name;
        if (!isset($this->settings['chooser_options']))
            $this->settings['chooser_options'] = "toolbar=no,menubar=no,scrollbars=yes,width=700,height=500";

        $out .= '<input id="' . $this->getID($form).'" type="hidden" name="' . $name . '" 
        value="' . htmlspecialchars($this->value) . '">';
        $out .= '<input id="' . $this->getID($form) . '_dp" name="' . $name . '_dp" ';
        $out .= 'value="' . htmlspecialchars($this->getDisplayValue()) . '" ';
        if ($this->settings['placeholder'] ?? false)
            $out .= ' placeholder="' . htmlspecialchars($this->settings['placeholder']) . '"';
        if (!($this->settings['autocomplete'] ?? true))
            $out .= " readonly";
        $out .= ($this->settings['input_options'] ?? '') . '>';
        //  $out.= '<input type="button" id="'.$this->getID($form).'_button" value="...">';

        if (!$this->settings['button'] ?? true)
            $out .= "
        <input type=button onClick='i" . $name . "=document." . $form->getName() .
                "." . $name . ";i" . $name . "_dp=document." .
                $form->getName() . '.' . $name . "_dp; " . $name .
                "_chooser=window.open(\"" . $target . "&target=i" . $name . '",
          "' . $name . "_chooser\", \"" .
                $this->settings['chooser_options'] . '"); ' . $name .
                "_chooser.i" . $name . "=i" . $name . "; " . $name . "_chooser.i" .
                $name . "_dp=i" . $name . "_dp; 
        window.i$name=i$name; window.i" . $name . "_dp=i" . $name . "_dp' value=\"...\">";
        if ($this->settings['autocomplete'] ?? true) {
            $out .= '<script>
            $("#' . $this->getID($form) . '_dp").autocomplete({
                source: function(request, response){
                    $.getJSON("' . $this->settings['target'] . '", {
                        json_query: request.term' .
                ($this->settings['json_param'] ?? '') . '
                    }, response )
                },
                select: function(event,ui){
                    $("#' . $this->getID($form) . '").val(ui.item.id)
                },
                change: function(event,ui){
                    if(! ui.item){
                        this.value=""
                        $("#' . $this->getID($form) . '").val("")
                    }
                },
                mustMatch: true,
                minLength: ' . ($this->settings['json_length'] ?? 1) . '
            })
            </script>';
        }
        return $out;

    }

}