<?php

namespace BayCMS\Field;

class TextInput extends Field
{

    public function getValue()
    {
        if ($this->value !== null)
            return $this->value;
        return "";
    }




    public function getInput(\BayCMS\Fieldset\Form $form): string
    {
        $out = "<input id=\"" . $this->getID($form) . "\" name=\"" . $this->name . "\" ";
        if ($this->settings['placeholder'] ?? '')
            $out .= 'placeholder="' . htmlspecialchars($this->settings['placeholder']) . '"';

        $out .= " value=\"" . htmlspecialchars($this->value) . "\"";
        $out .= ($this->settings['input_options'] ?? '') . ">";
        return $out;

    }



}