<?php

namespace BayCMS\Field;

class Time extends TextInput{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings){
        $options=$settings['input_options']??'';
        if(isset($settings['step'])) $options.=' step="'.$settings['step'].'"';
        $settings['input_options']=$options.' type="time"';
        parent::__construct($context, $settings);
    }  

    public function getValue()
    {
        if(! $this->value) return null;
        return $this->value;
    }
    
    public function getSQL($prefix = '')
    {
        if($this->get('sql')) return $this->get('sql');
        return "to_char($prefix".$this->getName().",'HH24:MI')";
    }

    public function setValue($value): bool
    {
        if($value){
            if(! isset($this->settings['step']) || $this->settings['step']==60) $format='H:i';
            else $format='H:i:s';
            $dt= new \DateTime($value);
            $value=$dt->format($format);
        } else $value=null;
        return parent::setValue($value);
    }
}