<?php

namespace BayCMS\Field;

class UploadFile extends Upload
{

    private function readFile(int $id): array
    {
        $uname = $this->settings['uname'] ?? $this->getName();
        $res = pg_query_params(
            $this->context->getRwDbConn(),
            'select f.id,f.de as uname from file f, objekt o 
                where f.id=o.id and o.id_obj=$1 and f.de=$2',
            [$id, $uname]
        );

        if (pg_num_rows($res))
            return pg_fetch_array($res, 0);
        else
            return ['uname' => $uname, 'id' => null];

    }
    public function save(\BayCMS\Fieldset\Form $form): bool
    {
        if (!$form->getId())
            return false;
        $f = $this->readFile($form->getId());

        $file = new \BayCMS\Base\BayCMSFile($this->context);
        if ($f['id'])
            $file->load($f['id']);
        $source = $this->fields->getField($this->getName() . "_location")->getValue();
        if (strstr($source, '/tmp/')) {
            $file->set([
                'name' => $this->fields->getField($this->getName() . "_name")->getValue(),
                'path' => $this->setttings['path'] ?? 'inc/named_files',
                'add_id_obj' => 1,
                'de' => $f['uname'],
                'source' => $source,
                'id_parent' => $form->getId()
            ]);
            $file->save();
        } elseif ($f['id'] && ($_POST[$this->getName() . '_del'] ?? false))
            $file->erase();

        $this->setFieldsFromDb($form->getId());
        $this->setValue('');
        return true;
    }


    private function setFieldsFromDb(int $id)
    {
        $f = $this->readFile($id);
        if ($f['id']) {
            $file = new \BayCMS\Base\BayCMSFile($this->context);
            $file->load($f['id']);
            $f = $file->get();
            $path = $this->context->get('BayCMSRoot') . '/' . $f['full_path'] . '/' . $f['name'];
            $this->fields->getField($this->getName() . '_location')->setValue($path);
            $this->fields->getField($this->getName() . '_name')->setValue($f['name']);
        }
    }

    public function setValue($value): bool
    {
        if ($this->get('non_empty') && !$this->fields->getField($this->getName() . '_location')->getValue())
            $this->error = true;

        $this->value = '';
        $location = $this->fields->getField($this->getName() . '_location')->getValue();
        $name = $this->fields->getField($this->getName() . '_name')->getValue();
        if ($location) {
            $res = pg_query_params(
                $this->context->getRwDbConn(),
                'select get_filetype_image($1)',
                [$name]
            );
            [$img] = pg_fetch_row($res, 0);
            $size = round(filesize($location) / 1024);
            $this->value .= "<a href=\"/" . $this->context->get('ls_link') . "/" . $this->context->get('lang') . "/top/gru/get.php?f=";
            $this->value .= urlencode($location);
            $this->value .= "&n=";
            $this->value .= urlencode($name);
            $this->value .= "\" target=\"_blank\">$img $name ($size kb)</a> ";
        }
        return $this->error;

    }

    public function setValueFromArray(array &$v, ?int $id = null): bool
    {
        parent::setValueFromArray($v, $id);
        if ( $id && ! isset($_POST[$this->getName() . '_name'])) {
            $this->setFieldsFromDb($id);
        }
        return $this->setValue('');

    }

    public function getDisplayValue()
    {
        return $this->value;
    }


}