<?php

namespace BayCMS\Field;

class UploadImage extends Upload
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings){
        $settings['accept']="image/png, image/jpeg, image/gif";
        $settings['preg_match']='/\\.(jpe?g|gif|png)$/i';
        parent::__construct($context,$settings);
    }

    private function readFile(int $id): array
    {
        $uname = $this->settings['uname'] ?? $this->getName();
        $res = pg_query_params(
            $this->context->getRwDbConn(),
            'select id,de as uname from bild  
                where id_obj=$1 and de=$2',
            [$id, $uname]
        );

        if (pg_num_rows($res))
            return pg_fetch_array($res, 0);
        else
            return ['uname' => $uname, 'id' => null];

    }
    public function save(\BayCMS\Fieldset\Form $form): bool
    {
        if (!$form->getId())
            return false;
        $f = $this->readFile($form->getId());

        $image = new \BayCMS\Base\BayCMSImage($this->context);
        if ($f['id'])
            $image->load($f['id']);
        $source = $this->fields->getField($this->getName() . "_location")->getValue();
        if (strstr($source, '/tmp/')) {
            $image->set([
                'name' => $this->fields->getField($this->getName() . "_name")->getValue(),
                'add_id_obj' => 1,
                'de' => $f['uname'],
                'source' => $source,
                'id_obj' => $form->getId(),
                'internal'=>$this->setttings['internal']??false,
                'height'=>$this->settings['height']??500,
                'theight'=>$this->settings['theight']??100
            ]);
            $image->save();
        } elseif ($f['id'] && ($_POST[$this->getName() . '_del'] ?? false))
            $image->erase();

        $this->setFieldsFromDb($form->getId());
        return true;
    }


    private function setFieldsFromDb(int $id)
    {
        $f = $this->readFile($id);
        if ($f['id']) {
            $image = new \BayCMS\Base\BayCMSImage($this->context);
            $image->load($f['id']);
            $f = $image->get();
            $path = $this->context->get('BayCMSRoot') . '/image/' . ($f['internal']?'intern/':'') . $f['name'];
            $this->fields->getField($this->getName() . '_location')->setValue($path);
            $this->fields->getField($this->getName() . '_name')->setValue($f['name']);
            $this->value=$this->getHTML($f['id']);
        }
    }

    public function getHTML($id,$prop=true){
        $out='';
        $image = new \BayCMS\Base\BayCMSImage($this->context);
        $image->load($id);
        $f = $image->get();
        $tn=($f['theight']>0?'t':'');
        $name=$tn.$f['name'];
        $location = $this->context->get('BayCMSRoot') . '/image/' . 
            ($f['internal']?'intern/':'') . $name;
        $out.='<img src="/'.$this->context->get('ls_link') . "/" . 
        $this->context->get('lang') . "/top/gru/get.php?f=";
        $out .= urlencode($location);
        $out .= "&n=";
        $out .= urlencode($name);
        $out.='" height='.$f[$tn.'y'].' width='.$f[$tn.'x'].'>';
        if($prop){
            $out.= "Size $f[x]x$f[y], Original $f[ox]x$f[ox]";
            if($tn) $out.=", Thumbnail $f[tx]x$f[ty]";
        }
        return $out;

    }

    public function setValue($value): bool
    {
        if ($this->get('non_empty') && !$this->fields->getField($this->getName() . '_location')->getValue())
            $this->error = true;

        return $this->error;

    }

    public function setValueFromArray(array &$v, ?int $id = null): bool
    {
        parent::setValueFromArray($v, $id);
        if ( $id && ! isset($_POST[$this->getName() . '_name'])) {
            $this->setFieldsFromDb($id);
        }

        return $this->setValue('');

    }

    public function getDisplayValue()
    {
        return $this->value;
    }


}