<?php

namespace BayCMS\FieldExtra;

use BayCMS\Field\Select;
use BayCMS\Field\TextInput;
class QBFilter extends QBOrder
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        parent::__construct($context, $settings);
        $this->fields = new \BayCMS\Fieldset\Fieldset();
        $this->fields->addField(new Select($context, [
            'name' => $this->getName() . '_con',
            'values' => ($settings['nr']??true)?['and', 'and not', 'or', 'or not']:['not'],
            'null' => 1
        ]));
        $this->fields->addField(new Select($context, [
            'name' => $this->getName() . '_bo',
            'values' => ['('],
            'null' => 1
        ]));
        $this->fields->addField(new Select($context, [
            'name' => $this->getName() . '_name',
            'values' => $this->settings['values'],
            'null' => 1
        ]));
        $this->fields->addField(new Select($context, [
            'name' => $this->getName() . '_op',
            'values' => ['=','!=','<=','>=','<','>','like','ilike','is null','null/empty'],
            'null' => 1
        ]));
        $this->fields->addField(new TextInput($context, [
            'name' => $this->getName() . '_val'
        ]));
        $this->fields->addField(new Select($context, [
            'name' => $this->getName() . '_bc',
            'values' => [')'],
            'null' => 1
        ]));
    }


    public function getInput(\BayCMS\Fieldset\Form $form): string
    {
        $out = '';
        foreach ($this->fields->getFields() as $f) {
            $out .= $f->getInput($form);
        }

        return $out;
    }

 
}