<?php

namespace BayCMS\FieldExtra;

use BayCMS\Field\Select;
use BayCMS\Field\Checkbox;
class QBOrder extends \BayCMS\Field\Field
{
    protected \BayCMS\Fieldset\Fieldset $fields;

    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        parent::__construct($context, $settings);
        $this->fields = new \BayCMS\Fieldset\Fieldset();

        $this->fields->addField(new Select($context, [
            'name' => $this->getName() . '_name',
            'values' => $this->settings['values'],
            'null' => 1
        ]));
        $this->fields->addField(new Checkbox($context, [
            'name' => $this->getName() . '_desc',
            'description'=>$this->t('descending','absteigend')
        ]));
    }

    public function setValueFromArray(array &$v, ?int $id = null): bool
    {
        $this->value=[];
        foreach($this->fields->getFields() as $f){
            $f->setValueFromArray($v,$id);
            $this->value[$f->getName()]=$f->getValue();
        }
        return $this->error;
    }

    public function getInput(\BayCMS\Fieldset\Form $form): string
    {
        $out = '';
        foreach ($this->fields->getFields() as $f) {
            $out .= $f->getInput($form);
        }
        $out .= ' <label for="' . $f->getID($form) . '"';
        $out .= ' style="width:auto;"';
        $out .= '>' . $f->getDescription() .'</label>';
        return $out;
    }

    public function getFormRow(\BayCMS\Fieldset\Form $form): string
    {
        $out = '<div class="' . $GLOBALS['TE']->getCSSClass('form_div') . '">';
        $out .= $this->getInput($form);
        if ($this->inline_error)
            $out .= "\n<br/><span class=\"form_inlineerror\">" . $this->inline_error . "</span>";
        $out .= "</div>\n";
        return $out;
    }
}