<?php

namespace BayCMS\FieldExtra;

use BayCMS\Field\TextInput;
use BayCMS\Field\Textarea;
class QBSQLField extends \BayCMS\Field\Field
{
    protected \BayCMS\Fieldset\Fieldset $fields;

    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        parent::__construct($context, $settings);
        $this->fields = new \BayCMS\Fieldset\Fieldset();

        $this->fields->addField(new TextInput($context, [
            'name' => $this->getName() . '_name',
            'description'=>$this->t('Field Name','Feld Name'),
            'values' => $this->settings['values'],
            'null' => 1
        ]));
        $this->fields->addField(new Textarea($context, [
            'name' => $this->getName() . '_sql',
            'description'=>'SQL-Code'
        ]));
    }

    public function setValueFromArray(array &$v, ?int $id = null): bool
    {
        $this->value=[];
        foreach($this->fields->getFields() as $f){
            $f->setValueFromArray($v,$id);
            $this->value[$f->getName()]=$f->getValue();
        }
        return $this->error;
    }

    public function getInput(\BayCMS\Fieldset\Form $form): string
    {
        $out = '';
        $f=$this->fields->getField(0);
        $out .= '<div style="float:left;"><label for="' . $f->getID($form) . '"';
        $out .= ' style="width:auto;"';
        $out .= '>' . $f->getDescription() .'</label><br/>';
        $out .= $f->getInput($form);
        $out.='</div><div>';
        $f=$this->fields->getField(1);
        $out .= $f->getInput($form);
        $out.='</div>';
        return $out;
    }

    public function getFormRow(\BayCMS\Fieldset\Form $form): string
    {
        $out = '<div class="' . $GLOBALS['TE']->getCSSClass('form_div') . '">';
        $out .= $this->getInput($form);
        if ($this->inline_error)
            $out .= "\n<br/><span class=\"form_inlineerror\">" . $this->inline_error . "</span>";
        $out .= "</div>\n";
        return $out;
    }
}