<?php
namespace BayCMS\Fieldset;

class Fieldset extends \BayCMS\Base\BayCMSBase
{

    protected array $fields;

    public function getFields(): array
    {
        return $this->fields;
    }

    public function getField($id): \BayCMS\Field\Field|bool
    {
        if (is_int($id))
            return $this->fields[$id] ?? false;
        foreach ($this->fields as $f) {
            if ($f->getName() == $id)
                return $f;
            if ($f->getDescription(false) == $id)
                return $f;
        }
        return false;
    }

    public function getFieldIndex($name): int
    {
        foreach ($this->fields as $k => $f) {
            if ($f->getName() == $name)
                return $k;
            if ($f->getDescription(false) == $name)
                return $k;
        }
        return -1;
    }

    public function addField(\BayCMS\Field\Field $field, int $index = null)
    {
        if($this->get('div_id') && ! $field->get('div_id')){
            $field->set(['div_id'=>$this->get('div_id')]);
        } elseif($field->get('div_id')!=$this->get('div_id')){
            $this->set(['div_id'=>$field->get('div_id')]);
        }
        if ($index === null)
            $this->fields[] = $field;
        else {
            $this->fields[$index] = $field;
            ksort($this->fields);
        }

    }

    public function delField($id)
    {
        unset($this->fields[$id]);
    }

}