<?php
namespace BayCMS\Page;

class BinPage extends Page {
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings=[]) {
        if(! isset($settings['file']))
            throw new \BayCMS\Exception\missingData('You have to give an file');
        if(! isset($settings['file_name']))
            throw new \BayCMS\Exception\missingData('You have to give an file_name');
        parent::__construct($context,$settings);
    }

    public function page($settings=[]){
        $path = tempnam($this->context->get('BayCMSRoot'), 'TESTFOLDER');
        $path = preg_replace("|[^/]+$|", "", $path);
        $path2 = $this->context->get('BayCMSRoot') . '/';
        
        if (!is_readable($this->settings['file']))
            $this->error('401 Not found','File with path '.$this->settings['file'].' not found');
        
        if (!preg_match("&^($path|$path2)&", $this->settings['file'])) 
            $this->error('404 Unautherized','File is not in BayCMS dir');

        $access = false;
        if (preg_match("&^($path|$path2)image/&", $this->settings['file'])) {
            
            if (!preg_match("&^($path|$path2)image/intern/&", $this->settings['file']))
                $access = true;
        
        
            if (!$access && ($this->context->get('row1')['power'] ?? 0) > 0) {
                $id = preg_replace('&.+/[ot]?([0-9]+)\\.[jpegnif]+$&', "\\1", $this->settings['file']);
                $res = pg_query_params(
                    $this->context->getDbConn(),
                    'select b.id from bild b, objekt_verwatlung' . $this->context->get('row1')['id'] . ' o
                where b.id_obj=o.id and b.id=$1',
                    [$id]
                );
                $access = pg_num_rows($res);
            }
        }
        
        
        if (!$access)
            $access = preg_match("&^($path|$path2)tmp/" . session_id() . "&", $this->settings['file']);
        
        if (!$access) {
            $file = preg_replace("&($path|$path2)&", '', $this->settings['file']);
            $res = pg_query_params(
                $this->context->getDbConn(),
                'select check_objekt(id,$2) from file where name=$1',
                [$file, $this->context->get('row1')['id_benutzer'] ?? 0]
            );
        
        
            if (!pg_num_rows($res))
                $this->error('401 Not found','This is not a regular BayCMS file');
            [$access] = pg_fetch_row($res, 0);
            if ($access != 't')
                $access = false;
            if (!$access) {
                //Download allowed when... see query...
                $res = pg_query_params(
                    $this->context->getDbConn(),
                    'select f.id from file f, verweis v where v.id_von=f.id and v.id_auf=$2 and v.ordnung<=$3 and f.name=$1',
                    [$file, $this->context->get('row1')['id'], $this->context->get('row1')['power'] ?? 0]
                );
                $access = pg_num_rows($res);
            }
        }
        if (!$access)
            $this->error('404 Unautherized','You do not have the rights to download the file');
        
        
        //All fine :-)
        
        $tmp_array = explode(".", $this->settings['file_name']);
        $endung = $tmp_array[count($tmp_array) - 1];
        $res = pg_query_params(
            $this->context->getDbConn(),
            'select mime from mime_types where endung=lower($1) or endung=$1',
            [$endung]
        );
        if (pg_num_rows($res))
            list($mime) = pg_fetch_row($res, 0);
        else
            $mime = "application/octet-stream";
        header("Content-type: $mime");
        header("Content-Transfer-Encoding: binary");
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        //header('Pragma: public');
        //header('Accept-Ranges: bytes');
        header("Content-Length: " . filesize($this->settings['file']));
        header("Content-disposition: inline; filename=".$this->settings['file_name']); // prompt to save to disk
        ob_clean();
        flush();
        readfile($this->settings['file']);
        exit;
    }
}