<?php

namespace BayCMS\Page;

class HTMLPage extends Page
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings = [])
    {
        if (!isset($settings['id']) && isset($_GET['id']))
            $settings['id'] = $_GET['id'];
        if (!isset($settings['id']) && isset($_GET['id_obj']))
            $settings['id'] = $_GET['id_obj'];
        if (!isset($settings['id']))
            throw new \BayCMS\Exception\missingData('You have to give an ID');
        parent::__construct($context, $settings);
    }


    public function page($settings = [])
    {
        $res = pg_query_params(
            $this->context->getDbConn(),
            'select non_empty(' . $this->context->getLangLang2('h.text_') . ') as text, h.min_power
            from html_seiten h, objekt o where h.id=o.id and o.geloescht is null and h.id=$1',
            [$this->settings['id']]
        );
        if (!pg_num_rows($res))
            $this->error(
                '404 Not found',
                'There is no HTML-Page with id=' . $this->settings['id']
            );

        $r = pg_fetch_array($res, 0);
        if ($r['min_power'] > $this->context->get('row1', 'power', 0))
            $this->error(
                '401 Unautherized',
                'You do not have sufficient rights to access HTML-Page with id=' . $this->settings['id']
            );

        $this->context->printHeader();
        echo $settings['pre_content'] ?? '';
        echo $GLOBALS['TE']->htmlPostprocess($r['text']);
        echo $settings['post_content'] ?? '';
        $this->context->printFooter();

    }
}