<?php

namespace BayCMS\Util;

class TabNavigation extends \BayCMS\Base\BayCMSBase
{
    public function __construct(\BayCMS\Base\BayCMSContext $context, array $settings)
    {
        if (!isset($settings['names']))
            throw new \BayCMS\Exception\missingData('You have to set at least "names"');

        if (!isset($settings['descriptions']))
            $settings['descriptions'] = $settings['names'];
        if (!isset($settings['urls'])) {
            $settings['urls'] = [];
            foreach ($settings['names'] as $name) {
                $settings['urls'][] = '?tab='.$name;
            }
        }
        for($i=0;$i<count($settings['urls']);$i++){
            if(strstr($_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'],$settings['urls'][$i].'?')){
                $settings['active']=$i;
                break;
            }
        }

        if (!isset($settings['active']))
            $settings['active'] = 0;
        $this->context = $context;
        $this->settings = $settings;
    }

    public function getNavigation()
    {
        $qs = $this->get('qs');
        $out = '';
        if ($GLOBALS['TE']->isBootstrap()) {
            $out .= '<ul class="nav nav-tabs">
          ';
            for ($i = 0; $i < count($this->get('names')); $i++) {
                $out .= '<li' . ($this->get('active') == $i ? ' class="active"' : '') . '>
                <a href="' . $this->addQS($this->settings['urls'][$i],$qs) . '">' .
                    $this->settings['descriptions'][$i] . '</a></li>' . "\n";
            }
            $out .= '</ul>';

        } else {
            $out.='<div id="navsite">
 <h5>Navigationsmenü:</h5>
 <ul>';
            $rows = [];
            $row = 0;
            $length = 0;
            $active_row = 0;

            for ($i = 0; $i < count($this->get('names')); $i++) {
                $length += 4 + mb_strlen($this->settings['descriptions'][$i], 'UTF-8');
                $rows[$row][] = $i;
                if ($i == $this->settings['active'])
                    $active_row = $row;
                if ($length > $this->get('max_length', 90)) {
                    $length = 0;
                    $row++;
                }
            }
            //Background rows
            for ($j = 0; $j < count($rows); $j++) {
                if ($j == $active_row)
                    continue;
                foreach ($rows[$j] as $i) {
                    $out .= '<li><a href="' . $this->addQS($this->settings['urls'][$i],$qs) . '">' .
                        $this->settings['descriptions'][$i] . '</a></li>' . "\n";
                }
            }
            //Active Row
            foreach ($rows[$active_row] as $i) {
                $out .= '<li><a' . ($this->get('active') == $i ? ' class="active"' : '') . 
                ' href="' . $this->addQS($this->settings['urls'][$i],$qs) . '">' .
                    $this->settings['descriptions'][$i] . '</a></li>' . "\n";
            }

            $out .= '</ul>
</div>';
        }
        return $out;
    }

    private function addQS($url,$qs){
        if(! $qs) return $url;
        if(! strstr($url,'?')) return $url.'?'.$qs;
        return $url.'&'.$qs;
    }




}